sp500 <- read.table("sp500.dat")
gs <- read.table("goldmanSacks.dat")
ford <- read.table("ford.dat")

# Add name "Data" in Line 1 in sp500.dat, then
D <- read.table("sp500.dates")
t <- D[,1]
D <- strptime(t, "%Y-%m-%d") #convert to  POSIXlt (a date class)
D <- D[2:659]

ps.options(horizontal=F, width=4.8, height=5, pointsize=9)
postscript("Fig314.eps", onefile=F, print=F)
par(mar=c(3,3,3,1),mfrow=c(3,1), mgp=c(1.8,0.6,0))

library(rugarch)
m1 = ugarchspec(variance.model=list(model="apARCH", garchOrder=c(1,1)), fixed.pars=list(delta=1),  mean.model=list(armaOrder=c(0,0), include.mean=F))
spA=ugarchfit(m1, 100*diff(log(sp500[,6])))
gsA=ugarchfit(m1, 100*diff(log(gs[,6])))
fdA=ugarchfit(m1, 100*diff(log(ford[,6])))


D <- D[2:658]
plot(D, 100*diff(log(sp500[,6])), type='l', xlab='', ylab='', ylim=c(-8.5, 6.5), 
    main='Daily returns of S&P500 index',col="blue")
lines(D, 2*sigma(spA), col="red")
lines(D, -2*sigma(spA), col="red")

plot(D, 100*diff(log(gs[,6])), type='l', xlab='', ylab='', 
    main='Daily returns of Goldman Sacks stock', col="blue")
lines(D, 2*sigma(gsA), col="red")
lines(D, -2*sigma(gsA), col="red")

plot(D, 100*diff(log(ford[,6])), type='l', xlab='', ylab='', 
    main='Daily returns of Ford stock', col="blue")
lines(D, 2*sigma(fdA), col="red")
lines(D, -2*sigma(fdA), col="red")
dev.off()

cat(length(sigma(spA)[(2*sigma(spA))>=abs(100*diff(log(sp500[,6])))])/length(sigma(spA)), "\n")
cat(length(sigma(gsA)[(2*sigma(gsA))>=abs(100*diff(log(gs[,6])))])/length(sigma(gsA)), "\n")
cat(length(sigma(fdA)[(2*sigma(fdA))>=abs(100*diff(log(ford[,6])))])/length(sigma(fdA)))
